c
c     version 1.0  Feb 1994
c
c     ----------------------------------------------------------------
c     |                                                              |
c     |            ***********  Z P L O T  ***********               |
c     |                                                              |
c     | An interactive plotting and picking program for seismic data |
c     |                                                              |
c     |                 Written by Colin A. Zelt                     |
c     |                                                              |
c     |                   Bullard Laboratories                       |
c     |                  University of Cambridge                     |
c     |                  Cambridge, UK  CB3 0EZ                      |
c     |                                                              |
c     ----------------------------------------------------------------
c
c
c     input: 
c            10 - data file (dfile)
c            12 - parameter file 'zplot.in'
c            13 - record file containing reducing velocity of data file
c                 and shot number, model position, azimuth and title for 
c                 each shot (rfile)
c            14 - theoretical traveltimes to overlay (txfile)
c            16 - active header file generated by program SGY2Z (hfile) 
c            18 - pick template file (tpfile)
c     output:
c            11 - log file 'zplot.out'
c            17 - trace energies 'energy.out'
c            19 - trace values (seismograms) 'z.out'
c
c
c     ----------------------------------------------------------------
c
c
      program main
c
      include 'zplot.par'
c
      parameter (nxmenu=8, nymenu=4, nimenu=nxmenu*nymenu, ninc=11)
c
      integer sint,tstart,tend,fhead(13),gain,colour(5),fmode,
     +  ishoti(ntmax),iflagi(ntmax),pickc(npickw),apick,
     +  ireci(ntmax),igaini(ntmax),iposp(ntmax),thead(22+npickw),
     +  ixmenu(nimenu),iymenu(nimenu),clmenu(nimenu),itmenu(nimenu),
     +  ndmenu(nimenu),imenu(nimenu),cnmenu(nimenu),itypei(ntmax),
     +  ibmenu(nimenu),idmenu(nimenu),ismenu(nimenu),isort(ntmax),
     +  ishstn(nsmax),itnf1(nsmax),itnf2(nsmax),itsn(ntmax)
      real tarray(npmax),tp(npmax),sp(npmax),seis(npmax),pcorr(ntmax),
     +  offsti(ntmax),xc(2),tc(2),xsmenu(nimenu),offstm(ntmax),
     +  tlincc(17),xtlim(ninc),xtinc(ninc),xmenu(nxmenu+1),
     +  ymenu(nymenu+1),rpicks(npickw),
     +  xcur(nxmenu+1),ycur(nymenu+1),picks(ntmax,npickw),xm(2),tm(2),
     +  xmen(nxmenu+1),ymen(nymenu+1),pilot1(npmax),pilot2(npmax),
     +  ccpilot(npmax),rmenu(nimenu),icmenu(nimenu),mamenu(nimenu),
     +  mimenu(nimenu),xsort(ntmax),xmod(nsmax),offstp(ntmax),
     +  azi(ntmax),az(nsmax),azim(ntmax),xd(2),minenratio,frhead(13),
     +  xtemp(nptemp),ttemp(nptemp),xtp(ntmax),ttp(ntmax),value(npickw),
     +  ymod(nsmax)
      character dfile*80,rfile*80,txfile*80,tlab*12,title*80,font*4,
     +          titler*80,hfile*80,flab*14,titlep*80,tpfile*80,
     +          kclass*1,kclpre*1
      character*14 chmenu(nimenu)
      equivalence (ntraces ,fhead(1)),(npts, fhead(2)),
     +            (sint, fhead(3)),(tstart,fhead(4)),
     +            (tend,fhead(5)),(nrec,fhead(6)),
     +            (npick,fhead(7)),(vredf,frhead(8)),
     +            (ifmt,fhead(9)),(xlatlong,frhead(10)),
     +            (xelev,frhead(11)),(xutm,frhead(12)),
     +            (cm,frhead(13)),(fhead,frhead)
      equivalence (iscale,imenu(1)),(amp,rmenu(2)),(rcor,rmenu(3)),
     +  (sf,rmenu(4)),(irec,imenu(5)),(itx,imenu(6)),
     +  (imute,imenu(7)),(iseg,imenu(8)),(ibndps,imenu(9)),
     +  (izerop,imenu(10)),(freqlo,rmenu(11)),(freqhi,rmenu(12)),
     +  (tlinc,rmenu(13)),(clip,rmenu(14)),(vred,rmenu(15))
      equivalence (ishade,imenu(16)),(spick,rmenu(17)),
     +  (ixaxis,imenu(18)),(itype,imenu(19)),(apick,imenu(20)),
     +  (nskip,imenu(21)),(xmm,rmenu(22)),(xmin,rmenu(23)),
     +  (xmax,rmenu(24)),(ndecim,imenu(25)),(tmm,rmenu(26)),
     +  (tmin,rmenu(27)),(tmax,rmenu(28))
      data colour/4,3,6,4,5/,
     +     tlincc/0.,.001,.002,.005,.01,.02,.05,.1,.2,.5,1.,2.,5.,
     +            10.,20.,50.,50./,
     +     xtlim/ .02, .05, .2, .5,2., 5.,20.,50.,200.,500.,1.e10/,
     +     xtinc/.001,.005,.01,.05,.1, .5, 1., 5., 10., 50.,100./,
     +     xmenu/0.,9.5,17.,26.,37.,47.,60.,73.,83.5/,
     +     ymenu/0.,1.5,3.,4.5,6./,
     +     pickc/2,3,4,5,6,8,17,27,22,7/,
     +     ixmenu/1,1,1,1,2,2,2,2,3,3,3,3,4,4,4,4,
     +            5,5,5,5,6,6,6,6,7,7,7,7,8,8,8,8/,
     +     iymenu/4,3,2,1,4,3,2,1,4,3,2,1,4,3,2,1,
     +            4,3,2,1,4,3,2,1,4,3,2,1,4,3,2,1/,
     +     xsmenu/5.,4.,5.,2., 3.5,4.5,4.5,4.5,
     +            6.,6.,5.,5., 4.,5.,5.,6.,
     +            4.5,5.5,4.5,5.5, 6.,6.,4.5,4.5,
     +            7.,6.,4.5,4.5, 0.,0.,0.,0./            
      data chmenu/'iscale:       ','amp:          ',
     +            'rcor:         ','sf:           ',
     +            'irec:         ','itx:          ',
     +            'imute:        ','iseg:         ',
     +            'ibndps:       ','izerop:       ',
     +            'freqlo:       ','freqhi:       ',
     +            'tlinc:        ','clip:         ',
     +            'vred:         ','ishade:       ',
     +            'spick:        ','ixaxis:       ',
     +            'itype:        ','pick:         ',
     +            'nskip:        ','xmm:          ',
     +            'xmin:         ','xmax:         ',
     +            'ndecim        ','tmm:          ',
     +            'tmin:         ','tmax:         ',
     +            'quit          ','orig/prev plot',
     +            'plot          ','auto pick     '/
      data ndmenu/-1,3,2,5, -1,-1,-1,-1, -1,-1,1,1, 3,2,2,-1,
     +            2,-1,-1,-1, -1,1,3,3, -1,1,3,3, 0,0,0,0/,
     +     clmenu/1,1,1,1, 1,1,1,1, 1,1,1,1, 1,1,1,1,
     +            1,1,1,-1, 1,1,1,1, 1,1,1,1, 3,3,3,-3/,            
     +     cnmenu/1,1,1,1, 1,1,1,1, 1,1,1,1, 1,1,1,1,
     +            1,1,1,-1, 1,1,1,1, 1,1,1,1, -2,-2,-2,-2/,
     +     ibmenu/0,0,0,0, 0,0,0,0, 0,0,1,1, 0,0,0,0,
     +            0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0/,
     +     ismenu/0,0,0,0, 1,0,0,0, 0,0,0,0, 0,0,0,0,
     +            0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0/,
     +     itmenu/3,5,0,5, 3,3,3,1, 3,1,2,2, 0,5,4,3,
     +            5,3,3,0, 3,4,2,2, 3,4,2,2, 0,0,0,0/,
     +     idmenu/0,0,0,0, 0,0,0,0,   0,0,12,11, 0,0,0,0,
     +            0,0,0,0, 0,0,24,23, 0,0,28,27, 0,0,0,0/
      data
     +icmenu/1.,1.25992,0.,1.25992, 1.,1.,1.,0., 
     +       1.,0.,0.5,0.5, 0.,1.25992,0.25,1.,
     +       1.25992,1.,1.,0., 1.,5.,0.,0., 
     +       1.,5.,0.,0., 0.,0.,0.,0./,
     +mimenu/0.,0.001,0.,.00001,         1.,-1,-1,0., 
     +       -2,0.,0.,0.,                0.,.01,0.,-2,
     +       .02,-5.,0.,0.,              1.,0.5,-999999.,-999999., 
     +        1.,0.5,-999999.,-999999.,  0.,0.,0.,0./,
     +mamenu/2.,0.,0.,0.,            999999.,2,1.,0., 
     +       1,0.,9999.,9999.,            0.,0.,9.99,2,
     +       0.,5.,999999.,0.,          100.,9999.,999999.,999999., 
     +       100.,9999.,999999.,999999.,  0.,0.,0.,0./
c
      common /hed/ fhead,thead,nbytes
      common /blk1/ ishoti,itsn,ireci,iflagi,offsti,igaini,picks,
     +              iposp,pcorr,offstm,offstp,azi,azim,itypei,rdepth
      common /blk3/ itnf1,itnf2,ishstn,xmod,ymod,az
      common /cplot/ iplot,isep,isegd,nseg,xwndow,ywndow,ibcol,ifcol,
     +               thick
c
      namelist /menupar/ vred,nskip,ndecim,irec,
     +                   iscale,amp,rcor,sf,tlinc,clip,
     +                   spick,itx,iseg,itype,
     +                   ibndps,freqlo,freqhi,izerop,
     +                   ishade,ixaxis,imute,
     +                   xmin,xmax,xmm,tmin,tmax,tmm
      namelist /pltpar/ iroute,pickc,ibw,idot,itemp,tpfile,tvg,pvg,
     +                  dfile,rfile,txfile,hfile,tener,iener,sdepth,
     +                  xpick,tcrcor,tlag,npoles,ipicko,iout,nout,
     +                  xwndow,ywndow,dens,ilr,tempwin,colour,iann,
     +                  vmute,tmute,iplot,annht,space,nbout,thick,
     +                  irefl,xminr,xincr,ndeca,icomp,title,azimuth,
     +                  twinener,minenratio,iscreen,overlap,fmode,font,
     +                  ialign,talign,ndiga,shadedc,iwater,vwater,
     +                  ipicks,rdepth,per
      namelist /axepar/ albht,amenht,orig,itrev,xscale,tscale,
     +                  ntickx,ndecix,ntickt,ndecit,
     +                  xmint,xmaxt,tmint,tmaxt,fmax
c
      per=.005
      rdepth=-999999.
      ipicks=0
      vwater=1.5
      sdepth=0.022
      iflagst=0
      iwater=0
      shadedc=0.
      ndiga=-1
      ialign=0
      talign=0.
      xscale=-1.
      tscale=-1.
      iann=0
      tvg=1.
      pvg=1.
      thick=-1.
      fmode=-1
      font='    '
      fmax=-1.
      txfile=''
      tpfile=''
      iout=0
      nout=0
      nbout=0
      tempwin=1.
      itemp=0
      overlap=10.
      iscreen=0
      twinener=.1
      minenratio=10.
      azimuth=-999.
      title=''
      icomp=999
      ndeca=1
      irefl=0
      xminr=0.
      xincr=.05
      itype=0
      space=0.
      annht=0.
      flab='FREQUENCY (Hz)'
      iplot=1
      imute=0
      vmute=0.
      tmute=0.
      tener=0.
      iener=0
      ipicko=0
      idot=1
      ixaxis=0
      ilr=1
      ishade=0
      dens=0.
      xwndow=0.
      ywndow=0.
      iopent=0
      ibndps=0
      freqlo=1.
      freqhi=20.
      izerop=1
      npoles=8
      ibw=1
      apick=1
      tcrcor=.30
      tlag=.10
      clip=0.
      iseg=0
      nseg=0
      itrev=0
      itx=0
      iroute=1
      spick=0. 
      xpick=0.
      xmint=-999999.
      xmaxt=-999999.
      tmint=-999999.
      tmaxt=-999999.
      tlinc=0.
      nskip=1
      ndecim=1
      vred=-1.
      iscale=0
      rcor=0.
      sf=.01
      albht=2.5
      amenht=-1.
      orig=12.5
      amp=1.
      xmm=230.
      tmm=130.
      ndecix=-2
      ndecit=-2
      ntickx=-1
      ntickt=-1
      iopentp=0
c
      open(12, file='zplot.in', status='old')
c
      read(12,menupar)
      read(12,pltpar)
      read(12,axepar)
      close(12)
c
      xscale0=xscale
      tscale0=tscale
c
      if(tmin.ge.tmax.or.xmin.ge.xmax) then
        write(*,*, fmt="(/
     +    '***  check values of tmin, tmax, xmin, xmax  ***'/)")
        stop
      end if
c
      if(iplot.eq.0) iplot=-1
      if(iplot.eq.2) iplot=0
      if(iplot.le.0) open(unit=19, file='p.out')
c
      call openf(dfile)
c
      if(npick.gt.npickw) then
        write(*,*, fmt="(/'***  npick > npickw  ***'/)")
        stop
      end if
c
      call readhr(hfile,rfile,ilr,irfile,nshot,azimuth,
     +            ishmin,ishmax)
c
      mimenu(5)=ishmin
      mamenu(5)=ishmax
      if(irec.lt.ishmin) irec=ishmin
      if(irec.gt.ishmax) irec=ishmax
c
      if(iroute.eq.1) open(11, file='zplot.out')
c
      if(iroute.le.1.and.amenht.le.0.) amenht=albht
      tminf=float(tstart)/1000.
      tmaxf=float(tend)/1000.
      sints=float(sint)/1000000.
      if(ishade.lt.-2.or.ishade.gt.2) ishade=0
      if(nskip.lt.1) nskip=1
      if(ndecim.lt.1) ndecim=1
      if(npoles.lt.4.) npoles=4
      if(mod(npoles,2).ne.0) npoles=8
      if(overlap.lt.0.) overlap=0.
      if(overlap.gt.90.) overlap=90.
      overlapu=1.-overlap/100.
      if(annht.le.0.) space=0.
c
      if(iseg.eq.1.or.iroute.ne.1) ibw=0
      if(ibw.eq.0) then
        ibcol=0
        ifcol=1
      else
        ibcol=1
        ifcol=0
      end if
      if(colour(1).eq.-1) then
        do 571 i=1,5
571        colour(i)=ifcol
        do 574 i=1,npick
574        pickc(i)=ifcol
        icolour=0
      else
        icolour=1
      end if 
      clmenu(29)=colour(2)
      clmenu(30)=colour(2)
      clmenu(31)=colour(2)
      clmenu(32)=-colour(2)
      if(iseg.eq.1) then
        nseg=nseg+1
      end if
      xwndw=xwndow
      ywndw=ywndow
      call plots(xwndw,ywndw,iroute)
ccc      if(fmode.ge.0) call rtxfon(font,fmode)
ccc      call grppix(ixwinp,iywinp)
ccc      call grpsiz(xwin,ywin)
      xwin=xwndow
      ywin=ywndow
      if(dens.le.0.) then
        dens=1.1*float(iywinp)/ywin
        if(thick.lt.-1.) dens=dens/abs(thick)
        write(6,565) dens
565     format(/'point density for trace shading: ',f12.3)
      end if
ccc      if(iroute.eq.1) call rrect(0.,0.,xwin,ywin,ibcol,0.)
      if(vredf.eq.0) then
        rvredf=0.
      else
        rvredf=1./vredf
      end if
      if(vred.lt.0.) vred=vredf
c
1002  continue
c
      rewind(13)
c
      iflags=1
      ishotp=-999999
      i=1
100   if(irfile.gt.0) then
        if(irec.gt.nshot) go to 99
        ishnum=i
        xmod(i)=0.
        ymod(i)=0.
        az(i)=0.
        titler=''
      else
        read(13,*,end=99) ishnum,xmod(i),ymod(i),az(i),titler
      end if
      if(ishnum.eq.irec) then
        ishotp=ishstn(i)
        itn1=itnf1(i)
        itn2=itnf2(i)
        xmodm=xmod(i)
        go to 99
      end if
      i=i+1
      go to 100
c
99    if(ishotp.lt.-999998) then
        ishotp=-1
        itn1=1
        itn2=1
        titler='>>>  record number not in record file  <<<'
      end if
c
      if(itn1.le.0) itn1=1
      if(itn2.le.0.or.itn2.gt.ntraces) itn2=ntraces
c
      if(ixaxis.lt.0) then
        ntt=itn2-itn1+1
        xminl=999999.
        xmaxl=-999999.
        do 980 i=itn1,itn2
           if(ixaxis.eq.-1) xposs=offsti(i)
           if(ixaxis.eq.-2) xposs=offstm(i)
           if(ixaxis.eq.-3) xposs=azi(i)
           if(ixaxis.eq.-4) xposs=azim(i)
           if(ixaxis.eq.-5) then
             if(ilr.ge.0) then
               xposs=float(itsn(i))
             else
               xposs=float(ntt-itsn(i)+1)
             end if
           end if
           if(xposs.lt.xminl) xminl=xposs
           if(xposs.gt.xmaxl) xmaxl=xposs
980     continue
        xmin=xminl-(xmaxl-xminl)*per 
        xmax=xmaxl+(xmaxl-xminl)*per 
      end if
c
      xminh=xmin
      xmaxh=xmax
      tminh=tmin
      tmaxh=tmax
      ndecxh=ndecix
      ndecth=ndecit
      ntckxh=ntickx
      ntckth=ntickt
      xminth=xmint
      xmaxth=xmaxt
      tminth=tmint
      tmaxth=tmaxt
      ishoth=irec
      xminm=xmin
      xmaxm=xmax
      tminm=tmin
      tmaxm=tmax
      iprev=1
c
1001  continue
c
      if(iprev.eq.0.and.ixaxism.lt.0.and.ixaxism.eq.ixaxis) 
     +   ixaxis=-ixaxis
c
      if(ixaxis.lt.0.and.iprev.ne.1) then
        ntt=itn2-itn1+1
        xmin=999999.
        xmax=-999999.
        do 990 i=itn1,itn2
           if(ixaxis.eq.-1) xposs=offsti(i)
           if(ixaxis.eq.-2) xposs=offstm(i)
           if(ixaxis.eq.-3) xposs=azi(i)
           if(ixaxis.eq.-4) xposs=azim(i)
           if(ixaxis.eq.-5) then
             if(ilr.ge.0) then
               xposs=float(itsn(i))
             else
               xposs=float(ntt-itsn(i)+1)
             end if
           end if
           if(xposs.lt.xmin) xmin=xposs 
           if(xposs.gt.xmax) xmax=xposs
990     continue 
      end if   
c
      if(xscale0.gt.0.) then
        xscale=xscale0
        xmm=(xmax-xmin)/xscale
      else
        xscale=(xmax-xmin)/xmm
      end if
      if(tscale0.gt.0.) then
        tscale=tscale0
        tmm=(tmax-tmin)/tscale
      else
        tscale=(tmax-tmin)/tmm
      end if
c
      if(iroute.eq.1) then
        iflagr=0
187     xlen=orig+xmm
        xlenm=orig+(xmenu(nxmenu+1)-0.25)*amenht
        ylenm=orig+tmm+2.5*albht+(ymenu(nymenu+1)-0.25)*amenht+space
        if(xlen.le.xwin.and.xlenm.le.xwin.and.
     +     ylenm.le.ywin.and.orig.ge.4.*albht) go to 186
        if(iflagr.eq.0) then
          if(albht.gt..1) albht=2.5
          orig=4.*albht
          iflagr=1
          go to 187
        end if
        if(iflagr.eq.1) then
          amaxm=(xwin-orig)/(xmenu(nxmenu+1)-0.25)
          if(amenht.gt.amaxm) amenht=amaxm
          iflagr=2
          go to 187 
        end if
        if(xmm.gt.xwin-orig) xmm=xwin-orig
        timax=ywin-orig-2.5*albht-(ymenu(nymenu+1)-0.25)*amenht-space
        if(tmm.gt.timax) tmm=timax
        xscale=(xmax-xmin)/xmm
        tscale=(tmax-tmin)/tmm
        iflagr=3
c
186     if(iflagr.gt.0) then
          write(*,*, fmt="
     +    (/'*** plot parameters adjusted to fit window  ***'/)")
          write(*,*) char(7)
        end if
      end if
c
      do 181 i=1,nxmenu+1
         xmen(i)=orig+xmenu(i)*amenht
         xcur(i)=xmen(i)-0.25*amenht
181   continue
      do 182 i=1,nymenu+1
         ymen(i)=orig+tmm+2.5*albht+ymenu(i)*amenht+space
         ycur(i)=ymen(i)-0.25*amenht
182   continue
c
      isegm=iseg
c
      if(vred.eq.0) then
        rvred=0.
      else
        rvred=1./vred
      end if
c
      if(vred.eq.0.) then
        nchart=8
        tlab='TIME (s)'
      else 
        i1=int(vred)
        id1=int((vred-float(i1))*10+.05)
        id2=int((vred-float(i1)-float(id1)/10.)*100.+.5)
        if(id1.eq.0.and.id2.eq.0) then
          nchart=9
          tlab='T-D/  (s)'
          tlab(5:5)=char(i1+48)
        else
          if(id2.eq.0) then
            nchart=11
            tlab='T-D/    (s)'
            tlab(5:7)=char(i1+48)//'.'//char(id1+48)
          else
            nchart=12
            tlab='T-D/     (s)'
            tlab(5:8)=char(i1+48)//'.'//char(id1+48)//char(id2+48)
          end if
        end if
      end if
c  
      if(iseg.eq.1) write(6,76) nseg
76    format(/'segment: ',i3)
c
      spickh=spick
      if(spick.gt.0.) pwidth=spick*2.54
c
      if(iscreen.eq.1) write(6,75) 
75    format(/
     +'   trc plt   trc seq  shot stn   rec stn    offset        gain'/
     +'--------------------------------------------------------------')
c
      call axtick(xmin,xmax,xmint,xmaxt,ntickx,ndecix)
      call axtick(tmin,tmax,tmint,tmaxt,ntickt,ndecit)
c
      if(itrev.ne.1) then
        tadj=tmin
      else
        tadj=tmax
        tscale=-tscale
      end if
c
ccc      if(iseg.eq.1) call gsegcr(nseg)
      if(iseg.eq.1) call segmnt
      call pcolor(ifcol)
ccc      call rtxcol(ifcol,ifcol)
      if(ipicko.ne.1) then
        if(abs(ixaxis).le.2) then
          call axis(orig,orig,xmin,xmax,xmm,xscale,0.,1,
     +       xmint,xmaxt,ntickx,ndecix,'DISTANCE (km)',13,albht)
        else
          if(abs(ixaxis).eq.3.or.abs(ixaxis).eq.4) then
            call axis(orig,orig,xmin,xmax,xmm,xscale,0.,1,
     +      xmint,xmaxt,ntickx,ndecix,'AZIMUTH (deg)',13,albht)
          else
            call axis(orig,orig,xmin,xmax,xmm,xscale,0.,1,
     +      xmint,xmaxt,ntickx,ndecix,'TSN',3,albht)
          end if
        end if
        if(ibndps.ge.0) then
          call axis(orig,orig,tmin,tmax,tmm,tscale,90.,1,
     +         tmint,tmaxt,ntickt,ndecit,tlab,nchart,albht)
        else
          fmin=0.
          if(fmax.le.0.) fmax=1./(sints*2.)
          fscale=(fmax-fmin)/tmm
          if(itrev.eq.1) fscale=-fscale
          fmint=-999999.
          fmaxt=-999999.
          ntickf=-1
          ndecif=-2
          call axtick(fmin,fmax,fmint,fmaxt,ntickf,ndecif)
          call axis(orig,orig,fmin,fmax,tmm,fscale,90.,1,
     +         fmint,fmaxt,ntickf,ndecif,flab,14,albht)
        end if
      end if
      call box(orig,orig,orig+xmm,orig+tmm)
      if(title.eq.'') then
        titlep=titler
      else
        titlep=title
      end if
      if(ipicko.ne.1) call symbol(orig+albht/2.,
     +   orig+tmm+albht/2.+space,1.25*albht,titlep,0.,80)
c
      if(tlinc.gt.0.) then
        if(ibndps.ge.0) then
          ttmin=tmin
          ttmax=tmax
          ttscale=tscale
          ttadj=tadj
        else
          ttmin=fmin
          ttmax=fmax
          ttscale=fscale
          if(itrev.ne.1) then
            ttadj=fmin
          else
            ttadj=fmax
          end if
        end if
        tls=float(nint(ttmin/tlinc))*tlinc
        sp(1)=orig 
        sp(2)=orig+xmm    
        itl=0
103     tp(1)=tls+float(itl)*tlinc
        if(tp(1).ge.ttmax) go to 104
        if(tp(1).gt.ttmin) then
          tp(1)=(tp(1)-ttadj)/ttscale+orig
          tp(2)=tp(1)
ccc          call gdash(3)
          call line(sp,tp,2)
        end if
        itl=itl+1
        go to 103
      end if
104   continue
c
c     plot the menu
c
      if(iroute.gt.1.and.amenht.eq.0.) go to 189
c
      call pcolor(colour(1))
      xp1=xcur(1)
      xp2=xcur(nxmenu+1)
      do 183 i=1,nymenu+1
         yp1=ycur(i)
         yp2=ycur(i) 
         call plot(xp1,yp1,3)
         call plot(xp2,yp2,2)
183   continue
c
      yp1=ycur(1)
      yp2=ycur(nymenu+1)
      do 184 i=1,nxmenu+1
         xp1=xcur(i)
         xp2=xcur(i) 
         call plot(xp1,yp1,3)
         call plot(xp2,yp2,2)
184   continue
      call pcolor(ifcol)
c
      do 1891 i=1,nimenu
c
         if(icolour.eq.0.and.i.ge.29.and.i.le.32) clmenu(i)=ifcol
         if((i.eq.20.or.i.eq.32).and.spick.le.0.) go to 1891
         if(clmenu(i).gt.-1.or.spick.gt.0.) 
     +     call mensym(xmen(ixmenu(i)),ymen(iymenu(i)),amenht,
     +                 chmenu(i),abs(clmenu(i)),ifcol)
c
         if(cnmenu(i).gt.-1) then
           if(ndmenu(i).eq.-1) then
             call mennum(xmen(ixmenu(i)),xsmenu(i),ymen(iymenu(i)),
     +         amenht,float(imenu(i)),ndmenu(i),cnmenu(i),ifcol)
           else
             call mennum(xmen(ixmenu(i)),xsmenu(i),ymen(iymenu(i)),
     +         amenht,rmenu(i),ndmenu(i),cnmenu(i),ifcol)
           end if
         else
           if(cnmenu(i).gt.-2.and.spick.gt.0.) call mennum
     +       (xmen(ixmenu(i)),xsmenu(i),ymen(iymenu(i)),amenht,
     +       float(imenu(i)),ndmenu(i),pickc(apick),pickc(apick))
         end if
c
1891  continue
c
ccc      call rtxcol(ifcol,ifcol)
         call pcolor(ifcol)
      call empty
c
189   continue
      iflagt=0
      icnt=0
      iplt=0
c
      ilim1=itn1
      ilim2=itn2
      ntt=itn2-itn1+1
      iflag1=0
      iflagb=0
      opx=orig+xmm
      opt=orig+tmm
      if(abs(xminm-xmin).gt..001.or.abs(xmaxm-xmax).gt..001.or.
     +   abs(tminm-tmin).gt..001.or.abs(tmaxm-tmax).gt..001.or.
     +   iprev.eq.1) then
        xminpr=xminm
        xmaxpr=xmaxm
        tminpr=tminm
        tmaxpr=tmaxm
      end if
      xminm=xmin
      xmaxm=xmax
      tminm=tmin
      tmaxm=tmax
      xmmm=xmm
      tmmm=tmm
      vredm=vred
      ixaxism=ixaxis
      itypem=itype
      icompm=icomp
      rvredm=rvred
c
      if(xmin.ge.xmax) then
        write(*,*, fmt="(/
     +    '***  check values of xmin and xmax  ***'/)")
        write(*,*) char(7)
        go to 1199 
      end if
c
      nplt=nint((tmax-tmin)/sints)+1
      if(nplt.lt.2.or.nplt.gt.npmax) then
        write(*,*, fmt="
     +       (/'***  npts<2 or npts>npmax  **')")
        write(*,*) char(7)
        go to 1199
      end if
c
      if(iener.eq.1) then
        open(17, file='energy.out')
        nener=nint(tener/sints)
      end if
c
111   do 10 itn=ilim1,ilim2
c
         call getsei(itn,seis,sints,iflag1,xminm,xmaxm,tminm,tmaxm,
     +        rvredm,rvredf,ishotp,tminf,tmaxf,icnt,nskip,nplt,
     +        npts,gain,iplt,n1,n2,iflag,itypem,icompm,ixaxism,
     +        iscreen,ifmt,ntt,ilr,ialign,talign,apick)
c
         if(iflag1.eq.0) then
           if(iflag.eq.0) go to 10
           if(iflagi(itn).le.0) go to 11
         end if
c
         if(imute.ne.0.and.vmute.gt.0.) then
           ttmute=tmute+abs(offsti(itn))*(1./vmute-rvredm)
           nmute=nint((ttmute-tminm)/sints)+1
           if(imute.gt.0) then
             if(nmute.le.n1) go to 10
             if(nmute.lt.n2) n2=nmute
             do 670 i=n2,nplt
                seis(i)=0.
670          continue
           else
             if(nmute.ge.n2) go to 10
             if(nmute.gt.n1) n1=nmute
             do 680 i=1,n1
                seis(i)=0.
680          continue
           end if
         end if
c
         if(iout.ne.2) call remdc(seis,nplt,1,nplt)
c
         if(ibndps.eq.1.or.ibndps.eq.-2) call bndpas(freqlo,freqhi,
     +                         sints,npoles,izerop,seis,nplt,iflagb)
c
         if(iout.gt.0) then
c
           open(19, file='z.out')
c
           if(nout.eq.0) then
             nout1=1
             nout2=nplt
           else
             if(picks(itn,apick).gt.-998..and.picks(itn,apick).ne.0.) 
     +       then
               tpick=picks(itn,apick)-pcorr(itn)+abs(offsti(itn))*
     +               (-rvredm)
             else
               go to 442
             end if
             nout1=nint((tpick-tminm)/sints)+1-nbout
             nout2=nout1+nout-1
             if(nout1.ge.nplt.or.nout2.le.1) go to 442
             if(nout1.lt.1) nout1=1
             if(nout2.gt.nplt) nout2=nplt
           end if
           write(19,475) (seis(i),i=nout1,nout2)
475        format(5e14.8)
           tso=tpick-nbout*sints
           write(29,462) ishoti(itn),itsn(itn),offsti(itn),tpick,tso
462        format(2i6,3f12.3)
         end if
c
442      if(iener.eq.1) then
c
           if(nener.eq.0) then
             nen1=1
             nen2=nplt
           else
             tpmin=9999.999
             do 341 i=1,npick
                if(picks(itn,i).gt.-998..and.picks(itn,i).ne.0.) then
                  tpick=picks(itn,i)-pcorr(itn)+abs(offsti(itn))*
     +                  (-rvredm)
                  if(tpick.lt.tpmin) tpmin=tpick
                end if
341          continue
             if(tpmin.gt.9999.) go to 342
             nen1=nint((tpmin-tminm)/sints)+1 
             nen2=nen1+nener
             if(nen1.ge.nplt.or.nen2.le.1) go to 342
             if(nen1.lt.1) nen1=1
             if(nen2.gt.nplt) nen2=nplt
           end if
           nepts=nen2-nen1+1
           sum=0.
           do 361 i=nen1,nen2
              sum=sum+seis(i)**2
361        continue
           energy=alog10((sum*gain**2)/float(nepts))
           write(17,362) ishoti(itn),itsn(itn),offsti(itn),float(gain),
     +                   energy
362        format(2i6,3f12.3)
         end if
c
342      if(irefl.gt.0) then
           sum=0.
           do 363 i=1,nplt
              sum=sum+seis(i)**2
363        continue
           if(sum.le.0.) then
             energy=-99.
           else
             energy=sum/float(nplt)
             if(irefl.gt.1) energy=alog10(energy)
           end if
           write(17,364) xminr+float(itsn(itn)-1)*xincr,energy
364        format(f12.3,e15.5)
         end if
c
         if(iflagt.eq.0) then
           do 30 i=1,nplt
              tarray(i)=(tminm+float(i-1)*sints-tadj)/tscale+orig
30         continue
           if(ibndps.lt.0) then
             ff=2.*fmax*sints
             do 31 i=1,nplt
31              tarray(i)=(tarray(i)-tarray(1))/ff+tarray(1)
           end if
           iflagt=1
         end if
c
         if(ibndps.lt.0) then
           nptsf=2**(int(.99999*alog10(float(nplt))/.301029995)+1)
           if(nptsf.lt.4) then
             write(6,373) 
373          format(/'***  npts<4 for fourier transform  ***'/)
             write(*,*) char(7)
             ibndps=0
             go to 374
           end if
           if(nptsf.gt.npmax) then
             write(6,371) 
371          format(/'***  npts>npmax for fourier transform  ***'/)
             write(*,*) char(7)
             ibndps=0
             go to 374
           end if
c
           call intrtr(seis,nplt,nptsf)
           call realft(seis,nptsf/2,1)
           call intrtr(seis,nptsf,nplt)
c
           do 372 i=1,nplt
              seis(i)=seis(i)**2
372        continue
         end if
374      continue
c
         if(iscale.eq.0.or.iscale.eq.2.or.sf.eq.0.) then
c
           if(iscale.eq.2) call vg2(seis,nplt,sints,tvg,pvg)
c
           ampmax=0.
           do 40 i=1,nplt
              if(abs(seis(i)).gt.ampmax) ampmax=abs(seis(i))
40         continue
           if(ampmax.gt.1.e-20) then
             if(iscale.eq.0.or.iscale.eq.2) then
               scalef=amp/ampmax
             else
               isf=4
               call mennum(xmen(ixmenu(isf)),xsmenu(isf),
     +              ymen(iymenu(isf)),amenht,rmenu(isf),
     +              ndmenu(isf),cnmenu(isf),ibcol)
c
               sf=amp/(ampmax*gain*abs(offsti(itn)/100.)**rcor)
               scalef=sf*gain*abs(offsti(itn)/100.)**rcor
               write(*,*, fmt="(/'sf = ',e12.5,
     +         ' based on first trace plotted'/)") sf
               write(*,*) char(7)
c
               call mennum(xmen(ixmenu(isf)),xsmenu(isf),
     +              ymen(iymenu(isf)),amenht,rmenu(isf),
     +              ndmenu(isf),cnmenu(isf),ifcol)
             end if
           else
             scalef=0.
           end if
         else
           scalef=sf*gain*abs(offsti(itn)/100.)**rcor
         end if
c
         ox=offstp(itn)-xminm
         np=1
         if(ibndps.lt.0) then
           n1=1
           n2=nint(ff*float(nplt-1))+1
         end if
c
         if(clip.le.0.) then
           sp(np)=(scalef*seis(n1)+ox)/xscale+orig
           tp(np)=tarray(n1)
           do 20 i=n1+1,n2-1,ndecim  
              np=np+1
              sp(np)=(scalef*seis(i)+ox)/xscale+orig
              tp(np)=tarray(i)
20         continue
           np=np+1
           sp(np)=(scalef*seis(n2)+ox)/xscale+orig
           tp(np)=tarray(n2)
         else
           sfsp=scalef*seis(n1)
           if(sfsp.gt.clip) sfsp=clip
           if(sfsp.lt.-clip) sfsp=-clip
           sp(np)=(sfsp+ox)/xscale+orig
           tp(np)=tarray(n1)
           do 21 i=n1+1,n2-1,ndecim  
              np=np+1
              sfsp=scalef*seis(i)
              if(sfsp.gt.clip) sfsp=clip
              if(sfsp.lt.-clip) sfsp=-clip
              sp(np)=(sfsp+ox)/xscale+orig
              tp(np)=tarray(i)
21         continue
           np=np+1
           sfsp=scalef*seis(n2)
           if(sfsp.gt.clip) sfsp=clip
           if(sfsp.lt.-clip) sfsp=-clip
           sp(np)=(sfsp+ox)/xscale+orig
           tp(np)=tarray(n2)
         end if
c
         if(iflag1.eq.-1) then
           icol=ibcol
         else
           icol=ifcol
         end if
         call pcolor(icol)
c
         if(ipicko.ne.1) then
           if(ishade.eq.0) then
c
             call line(sp,tp,np)
c
           else
c
             call shade(sp,tp,np,ishade,ox,xscale,orig,tmmm,dens,
     +                  shadedc)
c
           end if
         end if
c
         if(iflag1.eq.-1) then
           icol=1-ifcol
         else
           icol=1-ibcol
         end if
         call pcolor(icol)
c
         if(spick.gt.0..and.spickh.gt.0..and.ibndps.ge.0) then 
           xppick=(offstp(itn)-xminm)/xscale+orig+xpick
           do 340 i=1,npick
              if(picks(itn,i).gt.-998..and.picks(itn,i).ne.0.) then
                tpick=(picks(itn,i)-pcorr(itn)+abs(offsti(itn))*
     +                (-rvredm)-tadj)/tscale+orig
                if(tpick.ge.orig.and.tpick.le.(tmmm+orig)) then
                  ta=tpick
                  xa1=xppick
                  xa2=xa1+sign(1.,xpick)*spick
                  if(iflag1.eq.-1) then
                    ipcol=ibcol
ccc                    call garopt(1.,1.5)
                  else
                    ipcol=pickc(i)
ccc                    call garopt(1.,1.)
                  end if
                  if(ialign.eq.1) ta=ta+(talign-(picks(itn,apick)-
     +              abs(offsti(itn))*(rvred)))/tscale
ccc                  call garrow(xa1,ta,1,xa2,ta,0,ipcol,ipcol,pwidth)
                  call dot(xa1,ta,pwidth*8,ipcol)
                end if
              end if
340        continue 
         end if
c
11       if(iflag1.ne.0) then
           idcol=(1+(2*ibw-1)*iflag1)/2
           ircol=1-idcol
         else
           if(iflagi(itn).le.0.and.mod(icnt-1,nskip).eq.0) then
             idcol=ifcol
             ircol=-1
           else
             idcol=-1
             ircol=ifcol
           end if
         end if
         if(idot.gt.0.and.idcol.gt.-1) call dot((offstp(itn)-xminm)
     +            /xscale+orig,orig+tmmm+albht/4.,albht/3.,idcol)
         if(annht.gt.0..and.ircol.gt.-1) then
           if(mod(icnt-1,nskip*ndeca).eq.0) then
ccc             call rtxcol(ircol,ircol)
             call pcolor(ircol)
             if(iann.eq.0) then
               valuen=float(ireci(itn))
               call number((offstp(itn)-xminm)/xscale+orig+
     +            annht/2.,orig+tmmm+albht/4.,annht,valuen,90.,-1)
             else
               valuen=offsti(itn)
               call number((offstp(itn)-xminm)/xscale+orig-
     +            annht/2.,orig+tmmm+albht/3.,annht,valuen,0.,ndiga)
             end if
             if(iflag1.eq.-1) then
               icol=ibcol
             else
               icol=ifcol
             end if
ccc             call rtxcol(icol,icol)
             call pcolor(icol)
           end if
         end if
c
         call empty
c
10    continue
c
      if(iflag1.ne.0) go to 1199
c
      if(abs(itx).eq.1.and.ibndps.ge.0.and.abs(ixaxism).le.2) then
c
        if(iopent.eq.0) then
9091      open(14, file=txfile, status='old', err=9090, iostat=itfile)
9090      if(itfile.gt.0.or.txfile.eq.'') then
            write(6,394)
394         format(/'***  there is no traveltime file  ***')
            write(*,*) char(7)
            write(6,905)
905         format('enter name of traveltime file: ')
            read(5,995) txfile
            if(txfile.eq.'') go to 942
            go to 9091
          end if
c
          iopent=1
        else
          rewind(14)
        end if
c
        call pcolor(colour(3))
        iphase=-999
c
101     read(14,805,end=899) xf,tf,uf,if 
805     format(3f10.3,i10)
        if(if.eq.-1) go to 899
        if(if.eq.0) then
          xshotc=xf
          if(abs(xshotc-xmodm).lt..001) then
            iplttx=1
            tdc=uf 
          else
            iplttx=0
          end if
          iphase=-999
          go to 101
        end if
        if(iplttx.eq.1) then
          if(if.ne.iphase) then
            ipen=3
            iphase=if
          else
            ipen=2
          end if
          offset=abs(xf-xshotc)
          tf=tf+tdc-offset*rvredm
          if(abs(ixaxism).ne.2) then
            xf=float(itx)*(xf-xshotc)
          else
            xf=float(itx)*xf
          end if
          xf=(xf-xminm)/xscale+orig
          tf=(tf-tadj)/tscale+orig
          call plot(xf,tf,ipen)
        end if
        go to 101
899     continue
        call pcolor(ifcol)
      end if
c
      if(itx.eq.2.and.itemp.eq.1.and.ibndps.ge.0.and.ialign.ne.1) 
     +then
c
        if(iopentp.eq.0) call template(iopentp,tpfile,xtemp,
     +    ttemp,ntemp,rdepth,iflagm,iwater,vwater,sdepth)
        if(iflagm.eq.1) go to 942
c
        if(iplt.gt.1) then
c
          do 6102 i=1,iplt
6102         xsort(i)=offstp(iposp(i))
c
          call sort(xsort,isort,iplt)
c
          nptp=0
          do 896 i=1,iplt
             if(iflagi(iposp(isort(i))).le.0) go to 896
             j=iposp(isort(i))
             xpp=abs(offsti(j))
             do 893 ii=1,ntemp-1
                if((xpp.ge.xtemp(ii).and.xpp.le.xtemp(ii+1)).or.
     +             (xpp.le.xtemp(ii).and.xpp.ge.xtemp(ii+1))) then
                  tpp=(xpp-xtemp(ii))*(ttemp(ii+1)-ttemp(ii))/
     +                (xtemp(ii+1)-xtemp(ii))+ttemp(ii)
                  tpp=tpp-xpp*rvredm
                  xpp=offstp(j)
                  go to 894
                end if
893          continue
             go to 896
894          nptp=nptp+1
             xtp(nptp)=(xpp-xminm)/xscale+orig
             ttp(nptp)=(tpp-tadj)/tscale+orig
896       continue
          if(nptp.gt.1) then
            call pcolor(colour(4))
            call line(xtp,ttp,nptp)
            call pcolor(ifcol)
          end if
        end if
      end if
c
942   if(iplot.lt.0.or.iroute.ne.1) go to 1111
c 
1199  keyval=-999999.
c
119   keypre=keyval
      kclpre=kclass
      if(keypre.ne.2) nzpt=1 
      if(kclpre.ne.'m') nmpt=1
c
ccc      call rgloc(x,y,keyval,kclass)
      call get_event(x,y,keyval,kclass)
c
c      48 - 0        49 - 1
c      50 - 2        51 - 3
c      52 - 4        53 - 5
c
c      97 - a       100 - d
c     101 - e       104 - h
c     108 - l       109 - m
c     111 - o       112 - p
c     113 - q       114 - r
c     115 - s       116 - t
c     122 - z
c
      if(kclass.eq.'q') go to 1111
c
      if(kclass.eq.'p') go to 113
c
      if(kclass.eq.'e') then
        write(6,705)
705     format(/
     +' 1-icomp   2-iscreen  3-iout     4-idot      5-itemp'/
     +' 6-pickc   7-colour   8-xpick    9-annht    10-space'/
     +'11-ndeca  12-title   13-overlap 14-dens     15-npoles'/
     +'16-tcrcor 17-tlag    18-tempwin 19-twinener 20-minenratio'/
     +'21-vmute  22-tmute   23-nout    24-nbout    25-albht'/
     +'26-amenht 27-orig    28-itrev   29-fmax     30-tvg'/
     +'31-pvg    32-iann    33-thick   34-ndiga    35-shadedc')
790     write(6,715)
715     format(/
     +  'enter parameter number to change value (0 if done) : '$)
        read(5,*,err=790) npar
        if(npar.lt.1.or.npar.gt.35) go to 119
        if((npar.ne.6.and.npar.ne.7.and.npar.ne.12).or.
     +     (npar.eq.6.and.npick.eq.1)) then
          if(npar.eq.1) cval=icomp
          if(npar.eq.2) cval=iscreen
          if(npar.eq.3) cval=iout
          if(npar.eq.4) cval=idot
          if(npar.eq.5) cval=itemp
          if(npar.eq.6) cval=pickc(1)
          if(npar.eq.8) cval=xpick
          if(npar.eq.9) cval=annht
          if(npar.eq.10) cval=space
          if(npar.eq.11) cval=ndeca
          if(npar.eq.13) cval=overlap
          if(npar.eq.14) cval=dens
          if(npar.eq.15) cval=npoles
          if(npar.eq.16) cval=tcrcor
          if(npar.eq.17) cval=tlag
          if(npar.eq.18) cval=tempwin
          if(npar.eq.19) cval=twinener
          if(npar.eq.20) cval=minenratio
          if(npar.eq.21) cval=vmute
          if(npar.eq.22) cval=tmute
          if(npar.eq.23) cval=nout
          if(npar.eq.24) cval=nbout
          if(npar.eq.25) cval=albht
          if(npar.eq.26) cval=amenht
          if(npar.eq.27) cval=orig
          if(npar.eq.28) cval=itrev
          if(npar.eq.29) cval=fmax
          if(npar.eq.30) cval=tvg
          if(npar.eq.31) cval=pvg
          if(npar.eq.32) cval=iann
          if(npar.eq.33) cval=thick
          if(npar.eq.34) cval=ndiga
          if(npar.eq.35) cval=shadedc
791       write(6,725) cval
725       format('current parameter value:   ',f12.4/
     +           'enter new parameter value: '$)
          read(5,*,err=791) value(1)
        else
          if(npar.eq.12) then
792         write(6,755) titlep
755         format('current title:   ',a80/
     +             'enter new title: '$)
            read(5,995,err=792) title
995         format(a80)
            go to 790
          end if
          if(npar.eq.6) then
796         write(6,735) (pickc(i),i=1,npick)
735         format(
     +      'current parameter values:   ',<npick>i4/
     +      'enter new parameter values: '$)
            read(5,*,err=796) (value(i),i=1,npick)
          else
797         write(6,745) (colour(i),i=1,5) 
745         format(
     +      'current parameter values:   ',5i4/
     +      'enter new parameter values: '$)
            read(5,*,err=797) (colour(i),i=1,5)
            if(colour(1).eq.-1) then 
              do 5571 i=1,5 
5571             colour(i)=ifcol 
              do 5574 i=1,npick
5574             pickc(i)=ifcol 
              icolour=0 
            else 
              icolour=1 
            end if 
            clmenu(29)=colour(2) 
            clmenu(30)=colour(2) 
            clmenu(31)=colour(2) 
            clmenu(32)=-colour(2) 
            go to 790
          end if
        end if
        if(npar.eq.6) then
          do 780 i=1,npick
780          pickc(i)=value(i)
        else
          if(npar.eq.1) icomp=value(1)
          if(npar.eq.2) iscreen=value(1)
          if(npar.eq.3) iout=value(1)
          if(npar.eq.4) idot=value(1)
          if(npar.eq.5) itemp=value(1)
          if(npar.eq.8) xpick=value(1)
          if(npar.eq.9) annht=value(1)
          if(npar.eq.10) space=value(1)
          if(npar.eq.11) ndeca=value(1)
          if(npar.eq.13) overlap=value(1)
          if(npar.eq.14) dens=value(1)
          if(npar.eq.15) npoles=value(1)
          if(npar.eq.16) tcrcor=value(1)
          if(npar.eq.17) tlag=value(1)
          if(npar.eq.18) tempwin=value(1)
          if(npar.eq.19) twinener=value(1)
          if(npar.eq.20) minenratio=value(1)
          if(npar.eq.21) vmute=value(1)
          if(npar.eq.22) tmute=value(1)
          if(npar.eq.23) nout=value(1)
          if(npar.eq.24) nbout=value(1)
          if(npar.eq.25) albht=value(1)
          if(npar.eq.26) amenht=value(1)
          if(npar.eq.27) orig=value(1)
          if(npar.eq.28) itrev=value(1)
          if(npar.eq.29) fmax=value(1)
          if(npar.eq.30) tvg=value(1)
          if(npar.eq.31) pvg=value(1)
          if(npar.eq.32) iann=value(1)
          if(npar.eq.33) thick=value(1)
          if(npar.eq.34) ndiga=value(1)
          if(npar.eq.35) shadedc=value(1)
c
          if(tvg.le.0.) tvg=sints
          if(npoles.lt.4.) npoles=4
          if(mod(npoles,2).ne.0) npoles=8
          if(overlap.lt.0.) overlap=0.
          if(overlap.gt.90.) overlap=90.
          overlapu=1.-overlap/100.
          if(annht.le.0.) space=0.
c
        end if
        go to 790
      end if
c
      if(kclass.eq.'h') then
        if(x.gt.orig.and.x.lt.opx.and.y.gt.orig.and.y.lt.opt.
     +  and.iplt.gt.0) then
          xpos=(x-orig)*xscale+xminm
          dmin=999999.
          ipos=0
          do 1110 i=1,iplt
             dist=abs(offstp(iposp(i))-xpos)
             if(dist.lt.dmin) then
               dmin=dist
               ipos=i
             end if
1110      continue
c
          if(ipos.eq.0) go to 119
          i=iposp(ipos)
          do 1120 j=1,npick
             if(picks(i,j).gt.-998..and.picks(i,j).ne.0.) then
               rpicks(j)=picks(i,j)-abs(offsti(i))*rvredm
             else
               rpicks(j)=picks(i,j)
             end if
1120      continue
          write(6,1115) ishoti(i),iflagi(i),itsn(i),offsti(i),
     +                  ireci(i),offstm(i),itypei(i),azi(i),
     +      (picks(i,j),j=1,npick),(rpicks(j),j=1,npick)
1115        format(/
     +'shot station/number:    ',i12,  
     +'   dead trace flag:',i12/
     +'trace sequential number:',i12,
     +'   offset:         ',f12.3/
     +'receiver station/number:',i12,
     +'   position:       ',f12.3/
     +'data type:              ',i12,
     +'   azimuth:        ',f12.3/
     +'pick times:           ',<npick>f9.3/
     +'reduced pick times:   ',<npick>f9.3/)
c
          go to 119
        end if
      end if
c
      if(kclass.eq.'0'.or.kclass.eq.'1'.or.
     +   kclass.eq.'2'.or.kclass.eq.'3'.or.
     +   kclass.eq.'4'.or.kclass.eq.'5') then
        ntt=itn2-itn1+1
        xminl=999999.
        xmaxl=-999999.
        do 970 i=itn1,itn2
           if(abs(ixaxis).le.1) xposs=offsti(i)
           if(abs(ixaxis).eq.2) xposs=offstm(i)
           if(abs(ixaxis).eq.3) xposs=azi(i)
           if(abs(ixaxis).eq.4) xposs=azim(i)
           if(abs(ixaxis).eq.5) then
             if(ilr.ge.0) then
               xposs=float(itsn(i))
             else
               xposs=float(ntt-itsn(i)+1)
             end if
           end if
           if(xposs.ge.xminm.and.xposs.le.xmaxm) then
             if(kclass.eq.'0'.or.kclass.eq.'1') xposs=offsti(i)
             if(kclass.eq.'2') xposs=offstm(i)
             if(kclass.eq.'3') xposs=azi(i)
             if(kclass.eq.'4') xposs=azim(i)
             if(kclass.eq.'5') then
               if(ilr.ge.0) then
                 xposs=float(itsn(i))
               else
                 xposs=float(ntt-itsn(i)+1)
               end if
             end if
             if(xposs.lt.xminl) xminl=xposs
             if(xposs.gt.xmaxl) xmaxl=xposs
           end if
970     continue
        xmin=xminl-(xmaxl-xminl)*per 
        xmax=xmaxl+(xmaxl-xminl)*per 
        if(kclass.eq.'0') ixaxis=1
        if(kclass.eq.'1') ixaxis=1
        if(kclass.eq.'2') ixaxis=2 
        if(kclass.eq.'3') ixaxis=3
        if(kclass.eq.'4') ixaxis=4
        if(kclass.eq.'5') ixaxis=5
        go to 113
      end if
c
      if(kclass.eq.'l') then
        xminn=xmin-(xmax-xmin)*overlapu
        xmaxn=xmax-(xmax-xmin)*overlapu
        xmin=xminn
        xmax=xmaxn
        go to 113
      end if
c
      if(kclass.eq.'s') then
        iflagst=1
        xminst=xmin
        xmaxst=xmax
        tminst=tmin
        tmaxst=tmax
        irecst=irec
        ixaxisst=ixaxis
        go to 119
      end if
c
      if(kclass.eq.'t') then
        if(iflagst.ne.1) go to 119
        if(irec.ne.irecst) iflags=0
        xminh=xmin
        xmaxh=xmax
        tminh=tmin
        tmaxh=tmax
        irech=irec
        ixaxish=ixaxis
        xmin=xminst
        xmax=xmaxst
        tmin=tminst
        tmax=tmaxst
        irec=irecst
        ixaxis=ixaxisst
        xminst=xminh
        xmaxst=xmaxh
        tminst=tminh
        tmaxst=tmaxh
        irecst=irech
        ixaxisst=ixaxish
        go to 113
      end if
c
      if(kclass.eq.'o') then
        xmin=xminh
        xmax=xmaxh
        tmin=tminh
        tmax=tmaxh
        ndecix=ndecxh
        ndecit=ndecth
        ntickx=ntckxh
        ntickt=ntckth
        xmint=xminth
        xmaxt=xmaxth
        tmint=tminth
        tmaxt=tmaxth
        go to 114
      end if
c
      if(kclass.eq.'r') then
        xminn=xmin+(xmax-xmin)*overlapu
        xmaxn=xmax+(xmax-xmin)*overlapu
        xmin=xminn
        xmax=xmaxn
        go to 113
      end if
c
      if(kclass.eq.'z') then
        xcent=(x-orig)*xscale+xminm
        if(itrev.ne.1) then
          tcent=(y-orig)*tscale+tminm
        else
          tcent=(y-orig)*tscale+tmaxm
        end if
        xminn=xcent-(xmax-xmin)*.25
        xmaxn=xcent+(xmax-xmin)*.25
        tminn=tcent-(tmax-tmin)*.25
        tmaxn=tcent+(tmax-tmin)*.25
        xmin=xminn
        xmax=xmaxn
        tmin=tminn
        tmax=tmaxn
        go to 113
      end if
c
      if(keyval.eq.2) then
        if(keypre.ne.2) nzpt=1
        xc(nzpt)=x
        tc(nzpt)=y
ccc     call dot(xc(nzpt),tc(nzpt),-1.,1-ibw)
        call empty
        if(nzpt.eq.2) go to 112
        nzpt=nzpt+1
        go to 119
      end if
c
      if(kclass.eq.'d') then
        if(iplt.gt.0) then
          if(kclpre.ne.'d'.or.ndpt.eq.3) ndpt=1
          xd(ndpt)=(x-orig)*xscale+xminm
          if(ndpt.eq.2) then
c
            do 612 i=1,iplt
               j=iposp(i)
               if((offstp(j).ge.xd(1).and.offstp(j).le.xd(2)).or.
     +            (offstp(j).le.xd(1).and.offstp(j).ge.xd(2))) then
                 if(picks(j,apick).gt.-998..and.
     +           picks(j,apick).ne.0.) then
                   xppick=(offstp(j)-xminm)/xscale+orig+xpick
                   xa1=xppick
                   xa2=xa1+sign(1.,xpick)*spick
                   if(picks(j,apick).gt.-998..and.picks(j,apick).ne.0.)
     +             then
                     tpick=(picks(j,apick)-pcorr(j)+abs(offsti(j))*
     +                     (-rvredm)-tadj)/tscale+orig
                     if(tpick.ge.orig.and.tpick.le.(tmmm+orig)) then
                       ta=tpick
ccc                       call garopt(1.,1.5)
                       if(ialign.eq.1) ta=ta+(talign-(picks(itn,apick)-
     +                 abs(offsti(itn))*(rvred)))/tscale
ccc                       call garrow(xa1,ta,1,xa2,ta,0,ibcol,ibcol,
ccc     +                             pwidth)
                       call dot(xa1,ta,pwidth*8,ibcol)
                       call empty
                     end if
                     picks(j,apick)=0.
                     write(11,115) 
     +                 ishoti(j),itsn(j),apick,picks(j,apick)
                   end if
                 end if
               end if
612         continue
c
          end if
          ndpt=ndpt+1
        end if
        go to 119
      end if
c
      if(kclass.eq.'a') then
       if(itrev.ne.1) then
          talign=(y-orig)*tscale+tminm
        else
          talign=(y-orig)*tscale+tmaxm
        end if
        ialign=1
        go to 1113
      end if
c
      if(kclass.eq.'m'.and.abs(ixaxism).le.2) then
        if(kclpre.ne.'m'.or.nmpt.eq.3) nmpt=1
        xm(nmpt)=x
        tm(nmpt)=y
        call pcolor(colour(5))
        if(nmpt.eq.2) then
          xm1=(xm(1)-orig)*xscale+xminm
          xm2=(xm(2)-orig)*xscale+xminm
          if(itrev.ne.1) then 
            tm1=(tm(1)-orig)*tscale+tminm
            tm2=(tm(2)-orig)*tscale+tminm
          else
            tm1=(tm(1)-orig)*tscale+tmaxm
            tm2=(tm(2)-orig)*tscale+tmaxm
          end if
          if(abs(ixaxism).ne.2) then
            xm1=abs(xm1)
            xm2=abs(xm2)
          else
            xm1=abs(xm1-xmodm)
            xm2=abs(xm2-xmodm)
          end if  
          tm1=tm1+xm1*rvredm
          tm2=tm2+xm2*rvredm
          if(tm1.ne.tm2) then
            vmute=(xm2-xm1)/(tm2-tm1)
          else
            vmute=1.e10
          end if 
          tmute=tm1-xm1/vmute
          write(6,685) vmute,tmute
685       format(/'velocity: ',f10.3,' km/s   intercept: ',f10.3,' s')
          call plot(xm(1),tm(1),3)
          call plot(xm(2),tm(2),2)
        else
ccc       call dot(xm(1),tm(1),-1,1-ibw)
        end if
        nmpt=nmpt+1
        call pcolor(ifcol)
        call empty
        go to 119
      end if
c
      if(x.gt.orig.and.x.lt.opx.and.
     +   y.gt.orig.and.y.lt.opt.and.   
     +   keyval.eq.1) then
        if(iplt.gt.0) then
          xpos=(x-orig)*xscale+xminm
          dmin=999999.
          do 1102 i=1,iplt
             dist=abs(offstp(iposp(i))-xpos)
             if(dist.lt.dmin) then
               dmin=dist
               ipos=i
             end if
1102      continue
          ilim1=iposp(ipos)
          ilim2=iposp(ipos)
          iflagi(iposp(ipos))=-iflagi(iposp(ipos))
          write(11,115) ishoti(iposp(ipos)),itsn(iposp(ipos)),0,
     +                  float(iflagi(iposp(ipos)))
          iflag1=sign(1,iflagi(iposp(ipos)))
          go to 111
        end if
        go to 119
      end if
c
      if(x.gt.orig.and.x.lt.opx.and.y.gt.orig.and.y.lt.opt.
     +and.keyval.eq.3.and.spick.gt.0..and.spickh.gt.0..
     +and.ibndps.ge.0.and.ialign.ne.1) then
        if(iplt.gt.0) then
          xpos=(x-orig)*xscale+xminm
          dmin=999999.
          ipos=0
          do 1101 i=1,iplt
             dist=abs(offstp(iposp(i))-xpos)
             if(dist.lt.dmin.and.iflagi(iposp(i)).gt.0) then
               dmin=dist
               ipos=i
             end if
1101      continue
c
          if(ipos.eq.0) go to 119
c
          itn=iposp(ipos)
          xppick=(offstp(itn)-xminm)/xscale+orig+xpick
          xa1=xppick
          xa2=xa1+sign(1.,xpick)*spick
          if(picks(itn,apick).gt.-998..and.picks(itn,apick).ne.0.) 
     +    then
            tpick=(picks(itn,apick)-pcorr(itn)+abs(offsti(itn))*
     +            (-rvredm)-tadj)/tscale+orig
            if(tpick.ge.orig.and.tpick.le.(tmmm+orig)) then
              ta=tpick
ccc              call garopt(1.,1.5)
              if(ialign.eq.1) ta=ta+(talign-(picks(itn,apick)-
     +           abs(offsti(itn))*(rvred)))/tscale
ccc              call garrow(xa1,ta,1,xa2,ta,0,ibcol,ibcol,
ccc     +                    pwidth)
              call dot(xa1,ta,pwidth*8,ibcol)
              call empty
            end if
            picks(itn,apick)=0.
            write(11,115) ishoti(itn),itsn(itn),apick,picks(itn,apick)
115         format(3i6,f12.3)
          else   
            pickt=(y-orig)*tscale+tadj-abs(offsti(itn))*(-rvredm)
            ta=y
ccc            call garopt(1.,1.)
ccc            call garrow(xa1,ta,1,xa2,ta,0,pickc(apick),pickc(apick),
ccc     +                  pwidth)
            call dot(xa1,ta,pwidth*8,pickc(apick))
            call empty
c
            if(ialign.eq.1) pickt=pickt-talign+(picks(itn,apick)-
     +        abs(offsti(itn))*(rvred))
            picks(itn,apick)=pickt+pcorr(itn)
            write(11,115) ishoti(itn),itsn(itn),apick,picks(itn,apick)
          end if
        end if
        go to 119
      end if
c
      if(x.gt.xcur(ixmenu(13)).and.x.lt.xcur(ixmenu(13)+1).and.
     +   y.gt.ycur(iymenu(13)).and.y.lt.ycur(iymenu(13)+1)) then
        if(keyval.eq.1.or.keyval.eq.3) then
          call mennum(xmen(ixmenu(13)),xsmenu(13),ymen(iymenu(13)),
     +    amenht,rmenu(13),ndmenu(13),cnmenu(13),ibcol)
          do 191 i=1,15
             if(tlinc.ge.tlincc(i).and.tlinc.le.tlincc(i+1)) then
               ipos=i
               go to 192
             end if
191       continue
          ipos=16
192       continue
          if(keyval.eq.1) then
            if(tlinc.eq.tlincc(ipos)) then
              if(ipos.eq.1) go to 193
              tlinc=tlincc(ipos-1)
            else
              tlinc=tlincc(ipos)
            end if
          end if
          if(keyval.eq.3) then
            if(tlinc.eq.tlincc(ipos+1)) then
              if(ipos.eq.16) go to 193
              tlinc=tlincc(ipos+2)
            else
              tlinc=tlincc(ipos+1)
            end if
          end if
193       call mennum(xmen(ixmenu(13)),xsmenu(13),ymen(iymenu(13)),
     +    amenht,rmenu(13),ndmenu(13),cnmenu(13),ifcol)
        end if
        go to 119
      end if
c
      if(x.gt.xcur(ixmenu(3)).and.x.lt.xcur(ixmenu(3)+1).and.
     +   y.gt.ycur(iymenu(3)).and.y.lt.ycur(iymenu(3)+1)) then
        if(keyval.eq.1.or.keyval.eq.3) then
          call mennum(xmen(ixmenu(3)),xsmenu(3),ymen(iymenu(3)),
     +    amenht,rmenu(3),ndmenu(3),cnmenu(3),ibcol)
          if(keyval.eq.1) rcor=rcor-0.1
          if(rcor.lt.0.) rcor=0.            
          if(keyval.eq.3) rcor=rcor+0.1
          call mennum(xmen(ixmenu(3)),xsmenu(3),ymen(iymenu(3)),
     +    amenht,rmenu(3),ndmenu(3),cnmenu(3),ifcol)
        end if
        go to 119
      end if
c
      do 1892 i=1,nimenu
c
         if(itmenu(i).eq.1) then
           if(x.gt.xcur(ixmenu(i)).and.x.lt.xcur(ixmenu(i)+1).and.
     +        y.gt.ycur(iymenu(i)).and.y.lt.ycur(iymenu(i)+1)) then
             if(keyval.eq.1.or.keyval.eq.3) then
               call mennum(xmen(ixmenu(i)),xsmenu(i),ymen(iymenu(i)),
     +         amenht,float(imenu(i)),ndmenu(i),cnmenu(i),ibcol)
               imenu(i)=mod(imenu(i)+1,2)
               call mennum(xmen(ixmenu(i)),xsmenu(i),ymen(iymenu(i)),
     +         amenht,float(imenu(i)),ndmenu(i),cnmenu(i),ifcol)
               go to 1893
             end if
             go to 119
           end if
         end if
c
         if(itmenu(i).eq.2) then
           if(x.gt.xcur(ixmenu(i)).and.x.lt.xcur(ixmenu(i)+1).and.
     +        y.gt.ycur(iymenu(i)).and.y.lt.ycur(iymenu(i)+1)) then
             if(keyval.eq.1.or.keyval.eq.3) then
               call mennum(xmen(ixmenu(i)),xsmenu(i),ymen(iymenu(i)),
     +         amenht,rmenu(i),ndmenu(i),cnmenu(i),ibcol)
               xtdiff=abs(rmenu(i)-rmenu(idmenu(i)))
               do 201 j=1,ninc
                  if(xtdiff.lt.xtlim(j)) then
                    ipos=j
                    go to 202
                  end if
201            continue
               ipos=ninc
202            continue
               xtnew=float(nint(rmenu(i)/xtinc(ipos)))*xtinc(ipos)
               if(keyval.eq.1) then
                 if(xtnew.ge.rmenu(i)) then
                   rmenu(i)=xtnew-xtinc(ipos)
                 else
                   rmenu(i)=xtnew
                 end if
               end if
               if(keyval.eq.3) then
                 if(xtnew.le.rmenu(i)) then
                   rmenu(i)=xtnew+xtinc(ipos)
                 else
                   rmenu(i)=xtnew
                 end if
               end if
               if(rmenu(i).lt.mimenu(i)) rmenu(i)=mimenu(i)            
               if(rmenu(i).gt.mamenu(i)) rmenu(i)=mamenu(i)
               call mennum(xmen(ixmenu(i)),xsmenu(i),ymen(iymenu(i)),
     +         amenht,rmenu(i),ndmenu(i),cnmenu(i),ifcol)
               go to 1893
             end if
             go to 119
           end if
         end if
c
         if(itmenu(i).eq.3) then
           if(x.gt.xcur(ixmenu(i)).and.x.lt.xcur(ixmenu(i)+1).and.
     +        y.gt.ycur(iymenu(i)).and.y.lt.ycur(iymenu(i)+1)) then
             if(keyval.eq.1.or.keyval.eq.3) then
               call mennum(xmen(ixmenu(i)),xsmenu(i),ymen(iymenu(i)),
     +         amenht,float(imenu(i)),ndmenu(i),cnmenu(i),ibcol)
               if(keyval.eq.1) imenu(i)=imenu(i)-nint(icmenu(i))
               if(imenu(i).lt.nint(mimenu(i))) imenu(i)=nint(mamenu(i))
               if(keyval.eq.3) imenu(i)=imenu(i)+nint(icmenu(i))
               if(imenu(i).gt.nint(mamenu(i))) imenu(i)=nint(mimenu(i))
               call mennum(xmen(ixmenu(i)),xsmenu(i),ymen(iymenu(i)),
     +         amenht,float(imenu(i)),ndmenu(i),cnmenu(i),ifcol)
               go to 1893
             end if
             go to 119
           end if
         end if
c
         if(itmenu(i).eq.4) then
           if(x.gt.xcur(ixmenu(i)).and.x.lt.xcur(ixmenu(i)+1).and.
     +        y.gt.ycur(iymenu(i)).and.y.lt.ycur(iymenu(i)+1)) then
             if(keyval.eq.1.or.keyval.eq.3) then
               call mennum(xmen(ixmenu(i)),xsmenu(i),ymen(iymenu(i)),
     +         amenht,rmenu(i),ndmenu(i),cnmenu(i),ibcol)
               vnew=float(nint(rmenu(i)/icmenu(i)))*icmenu(i)
               if(keyval.eq.1) then
                 if(vnew.ge.rmenu(i)) then
                   rmenu(i)=vnew-icmenu(i)
                 else
                   rmenu(i)=vnew
                 end if
               end if
               if(keyval.eq.3) then
                 if(vnew.le.rmenu(i)) then
                   rmenu(i)=vnew+icmenu(i)
                 else
                   rmenu(i)=vnew
                 end if
               end if
               if(rmenu(i).lt.mimenu(i)) rmenu(i)=mimenu(i)            
               if(rmenu(i).gt.mamenu(i)) rmenu(i)=mamenu(i)
               call mennum(xmen(ixmenu(i)),xsmenu(i),ymen(iymenu(i)),
     +         amenht,rmenu(i),ndmenu(i),cnmenu(i),ifcol)
               go to 1893
             end if
             go to 119
           end if
         end if
c
         if(itmenu(i).eq.5) then
           if(x.gt.xcur(ixmenu(i)).and.x.lt.xcur(ixmenu(i)+1).and.
     +        y.gt.ycur(iymenu(i)).and.y.lt.ycur(iymenu(i)+1)) then
             if(keyval.eq.1.or.keyval.eq.3) then
               call mennum(xmen(ixmenu(i)),xsmenu(i),ymen(iymenu(i)),
     +         amenht,rmenu(i),ndmenu(i),cnmenu(i),ibcol)
               if(keyval.eq.1) then
                 rmenu(i)=rmenu(i)/icmenu(i)
                 if(rmenu(i).lt.mimenu(i)) rmenu(i)=0.
               end if
               if(keyval.eq.3) then
                 rmenu(i)=rmenu(i)*icmenu(i)
                 if(rmenu(i).eq.0.) rmenu(i)=mimenu(i)
               end if
               call mennum(xmen(ixmenu(i)),xsmenu(i),ymen(iymenu(i)),
     +         amenht,rmenu(i),ndmenu(i),cnmenu(i),ifcol)
             end if
             go to 119
           end if
         end if
c
         go to 1892
c
1893     continue
c
         if(ibmenu(i).eq.1) iflagb=0
         if(ismenu(i).eq.1) iflags=0
         go to 119
c
1892  continue
c
      if(x.gt.xcur(ixmenu(20)).and.x.lt.xcur(ixmenu(20)+1).and.
     +   y.gt.ycur(iymenu(20)).and.y.lt.ycur(iymenu(20)+1)) then
        if(spick.gt.0..and.spickh.gt.0.and.
     +    (keyval.eq.1.or.keyval.eq.3)) then
          call mennum(xmen(ixmenu(20)),xsmenu(20),ymen(iymenu(20)),
     +    amenht,float(imenu(20)),ndmenu(20),abs(cnmenu(20)),ibcol)
          if(keyval.eq.1) apick=apick-1
          if(keyval.eq.3) apick=apick+1
          if(apick.lt.1) apick=npick
          if(apick.gt.npick) apick=1
          call mennum(xmen(ixmenu(20)),xsmenu(20),ymen(iymenu(20)),
     +    amenht,float(imenu(20)),ndmenu(20),pickc(apick),ifcol)
ccc          call rtxcol(ifcol,ifcol)
          call pcolor(ifcol)
        end if
        go to 119
      end if
c
      if(x.gt.xcur(ixmenu(32)).and.x.lt.xcur(ixmenu(32)+1).and.
     +   y.gt.ycur(iymenu(32)).and.y.lt.ycur(iymenu(32)+1)) then
        if(spick.gt.0..and.spickh.gt.0..and.ibndps.ge.0.and.
     +  ialign.ne.1) then
          if(keyval.eq.1.and.iplt.gt.2) then
c
            ncrcor=nint(tcrcor/sints)+1
            nlag=nint(tlag/sints)
c
            do 602 i=1,iplt
602            xsort(i)=offstp(iposp(i))
c
            call sort(xsort,isort,iplt)
c
            np1=0
            i=1
601         if(i.gt.iplt) go to 119
            if(iflagi(iposp(isort(i))).gt.0) then
              j=iposp(isort(i))
              if(picks(j,apick).gt.-998..and.
     +           picks(j,apick).ne.0.) then
                tpick=picks(j,apick)-pcorr(j)+abs(offsti(j))*
     +                (-rvredm)
                tppick=(tpick-tadj)/tscale+orig
                if(tppick.ge.orig.and.tppick.le.(tmmm+orig)) then
                  if(np1.eq.0) then
                    np1=i
                    tp1=tpick
                    i=i+1
                    go to 601
                  else
                    np2=i
                    tp2=tpick
                    if(np2.gt.np1+1) then
                      is1=isort(np1)
                      is2=isort(np2)
                      xp1=offstp(iposp(is1))  
                      xp2=offstp(iposp(is2))  
                      ns1=nint((tp1-tminm)/sints)+1
                      ns2=nint((tp2-tminm)/sints)+1
                      ne1=ns1+ncrcor-1
                      ne2=ns2+ncrcor-1
                      if(ne1.le.nplt.and.ne2.le.nplt) then    
c
                        call getsei(iposp(is1),seis,sints,1,xminm,
     +                    xmaxm,tminm,tmaxm,rvredm,rvredf,ishotp,
     +                    tminf,tmaxf,1,1,nplt,npts,gain,
     +                    iplt,n1,n2,iflag,itypem,icompm,ixaxism,
     +                    iscreen,ifmt,ntt,ilr,ialign,talign,apick)
c
                        if(ibndps.eq.1) then
                          call remdc(seis,nplt,1,nplt)
c
                          if(ibndps.eq.1) call bndpas(freqlo,freqhi,
     +                                    sints,npoles,izerop,
     +                                    seis,nplt,iflagb)
                        end if
c
                        call remdc(seis,nplt,ns1,ne1)
c
                        ampmx1=0.
                        do 151 k=1,ncrcor
                           pilot1(k)=seis(ns1+k-1)
                           if(abs(pilot1(k)).gt.ampmx1) 
     +                       ampmx1=abs(pilot1(k))
151                     continue
c
                        call getsei(iposp(is2),seis,sints,1,xminm,
     +                    xmaxm,tminm,tmaxm,rvredm,rvredf,ishotp,
     +                    tminf,tmaxf,1,1,nplt,npts,gain,
     +                    iplt,n1,n2,iflag,itypem,icompm,ixaxism,
     +                    iscreen,ifmt,ntt,ilr,ialign,talign,apick)
c
                        if(ibndps.eq.1) then
                          call remdc(seis,nplt,1,nplt)
c
                          if(ibndps.eq.1) call bndpas(freqlo,freqhi,
     +                                    sints,npoles,izerop,
     +                                    seis,nplt,iflagb)
                        end if
c
                        call remdc(seis,nplt,ns2,ne2)
c
                        ampmx2=0.
                        do 152 k=1,ncrcor
                           pilot2(k)=seis(ns2+k-1)
                           if(abs(pilot2(k)).gt.ampmx2) 
     +                       ampmx2=abs(pilot2(k))
152                     continue
c
                        s=(tp2-tp1)/(xp2-xp1)
                        b=tp1-s*xp1
                        do 611 k=np1+1,np2-1
                           ipsk=iposp(isort(k))
                           if(iflagi(ipsk).gt.0) then
c
                             call getsei(ipsk,seis,sints,1,xminm,
     +                         xmaxm,tminm,tmaxm,rvredm,rvredf,ishotp,
     +                         tminf,tmaxf,1,1,nplt,npts,gain,
     +                         iplt,n1,n2,iflag,itypem,icompm,ixaxism,
     +                         iscreen,ifmt,ntt,ilr,ialign,talign,apick)
c
                             if((offstp(ipsk).gt.xp1.and.offstp(ipsk).
     +                       gt.xp2).or.(offstp(ipsk).lt.xp1.and.
     +                       offstp(ipsk).lt.xp2)) go to 611
c
                             if(ibndps.eq.1) then
                               call remdc(seis,nplt,1,nplt)
c
                               if(ibndps.eq.1) 
     +                             call bndpas(freqlo,freqhi,
     +                                         sints,npoles,izerop,
     +                                         seis,nplt,iflagb)
                             end if
c
                             w1=abs((xp2-offstp(ipsk))/(xp2-xp1))/
     +                          ampmx1
                             w2=abs((xp1-offstp(ipsk))/(xp2-xp1))/
     +                          ampmx2
                             do 153 l=1,ncrcor
                                ccpilot(l)=w1*pilot1(l)+w2*pilot2(l) 
153                          continue
c
                             tline=s*offstp(ipsk)+b
                             nline=nint((tline-tminm)/sints)+1
c
                             call remdc(seis,nplt,nline-nlag,
     +                                  nline+nlag+ncrcor-1)
c
                             call crscor(pilot1,ncrcor,seis,nplt,
     +                                   nline,nlag,lag1)
                             call crscor(pilot2,ncrcor,seis,nplt,
     +                                   nline,nlag,lag2)
                             call crscor(ccpilot,ncrcor,seis,nplt,
     +                                   nline,nlag,lag0)
c
                             lagmin=min(lag1,lag2,lag0)
                             lagmax=max(lag1,lag2,lag0)
c
                             if(abs(lagmax-lagmin).lt.nlag.
     +                          or.ipicks.eq.1) then
                               tpk=tline+float(lag0)*sints 
                               xppick=(offstp(ipsk)-xminm)/xscale+orig+
     +                                xpick
                               xa1=xppick
                               xa2=xa1+sign(1.,xpick)*spick
                               tppick=(tpk-tadj)/tscale+orig
                               ta=tppick
ccc                               call garopt(1.,1.)
                               if(ialign.eq.1) ta=ta+(talign-
     +                         (picks(itn,apick)-
     +                         abs(offsti(itn))*(rvred)))/tscale
ccc                               call garrow(xa1,ta,1,xa2,ta,0,
ccc     +                              pickc(apick),pickc(apick),pwidth)
                               call dot(xa1,ta,pwidth*8,pickc(apick))
c
                               picks(ipsk,apick)=
     +                              tpk-abs(offsti(ipsk))*
     +                              (-rvredm)+pcorr(ipsk)
                               write(11,115) ishoti(ipsk),itsn(ipsk),
     +                                       apick,picks(ipsk,apick)
                             end if
                           end if
611                     continue
                        call empty
                      end if
                    end if
                  end if
                end if 
                np1=i
                tp1=tpick
              end if
            end if
            i=i+1
            go to 601
          end if
c
          if(keyval.eq.3.and.iplt.gt.0) then
c
            if(itemp.eq.1.and.iopentp.eq.0) call template(iopentp,
     +        tpfile,xtemp,ttemp,ntemp,rdepth,iflagm,iwater,
     +        vwater,sdepth)
            if(iflagm.eq.1) go to 119
            nwind=nint(twinener/sints)+1
c
            i=1
701         if(i.gt.iplt) go to 119
            j=iposp(i)
            if(iflagi(j).le.0.or.(picks(j,apick).gt.-998..and.
     +      picks(j,apick).ne.0.)) then
              i=i+1
              go to 701
            end if
c
            call getsei(j,seis,sints,1,xminm,xmaxm,tminm,tmaxm,
     +        rvredm,rvredf,ishotp,tminf,tmaxf,1,1,nplt,npts,gain,
     +        iplt,n1,n2,iflag,itypem,icompm,ixaxism,iscreen,ifmt,
     +        ntt,ilr,ialign,talign,apick)
c
            if(ibndps.eq.1) then
              call remdc(seis,nplt,1,nplt)
c
              if(ibndps.eq.1) call bndpas(freqlo,freqhi,
     +                        sints,npoles,izerop,
     +                        seis,nplt,iflagb)
            end if
c
            call remdc(seis,nplt,1,nplt)
c
            if(iopentp.eq.1) then
              xpp=abs(offsti(j))
              do 793 ii=1,ntemp-1
                 if((xpp.ge.xtemp(ii).and.xpp.le.xtemp(ii+1)).or.
     +              (xpp.le.xtemp(ii).and.xpp.ge.xtemp(ii+1))) then
                   tpp=(xpp-xtemp(ii))*(ttemp(ii+1)-ttemp(ii))/
     +                 (xtemp(ii+1)-xtemp(ii))+ttemp(ii)
                   tpp1=tpp-tempwin-xpp*rvredm
                   tpp2=tpp+tempwin-xpp*rvredm
                   n1=max(n1,nint((tpp1-tminm)/sints)+1-nwind)
                   n2=min(n2,nint((tpp2-tminm)/sints)+1+nwind)
                   go to 794
                 end if
793           continue
            end if
c
794         call pick(seis,nplt,n1,n2,tminm,tepick,nwind,sints,iflagp,
     +                minenratio)
c
            if(iflagp.eq.1) then
              tpk=tepick
              xppick=(offstp(j)-xminm)/xscale+orig+
     +               xpick
              xa1=xppick
              xa2=xa1+sign(1.,xpick)*spick
              tppick=(tpk-tadj)/tscale+orig
              ta=tppick
ccc              call garopt(1.,1.)
              if(ialign.eq.1) ta=ta+(talign-(picks(itn,apick)-
     +          abs(offsti(itn))*(rvred)))/tscale
ccc              call garrow(xa1,ta,1,xa2,ta,0,
ccc     +             pickc(apick),pickc(apick),pwidth)
              call dot(xa1,ta,pwidth*8,pickc(apick))
c
              picks(j,apick)=
     +             tpk-abs(offsti(j))*
     +             (-rvredm)+pcorr(j)
              write(11,115) ishoti(j),itsn(j),
     +                      apick,picks(j,apick)
              call empty
            end if
            i=i+1
            go to 701
          end if
          go to 119
        end if
      end if
c
      if(x.gt.xcur(ixmenu(31)).and.x.lt.xcur(ixmenu(31)+1).and.
     +   y.gt.ycur(iymenu(31)).and.y.lt.ycur(iymenu(31)+1)) then
        if(keyval.eq.1.or.keyval.eq.3) then
          if(keyval.eq.1) then
            ibcol=1
            ifcol=0
            ibw=1    
          end if
          if(keyval.eq.3) then    
            ibcol=0
            ifcol=1
            ibw=0
          end if
          if(icolour.eq.0) then
            do 572 i=1,5
572            colour(i)=ifcol
            do 576 i=1,npick
576            pickc(i)=ifcol
          end if
          go to 113
        end if
        go to 119
      end if
c
      if(x.gt.xcur(ixmenu(30)).and.x.lt.xcur(ixmenu(30)+1).and.
     +   y.gt.ycur(iymenu(30)).and.y.lt.ycur(iymenu(30)+1)) then
        if(keyval.eq.1) then
          xmin=xminh
          xmax=xmaxh
          tmin=tminh
          tmax=tmaxh
          ndecix=ndecxh
          ndecit=ndecth 
          ntickx=ntckxh
          ntickt=ntckth
          xmint=xminth
          xmaxt=xmaxth
          tmint=tminth
          tmaxt=tmaxth
          go to 114
        end if
        if(keyval.eq.3) then
          xmin=xminpr
          xmax=xmaxpr
          tmin=tminpr
          tmax=tmaxpr
          go to 113
        end if
        go to 119
      end if
c
      if(x.gt.xcur(ixmenu(29)).and.x.lt.xcur(ixmenu(29)+1).and.
     +   y.gt.ycur(iymenu(29)).and.y.lt.ycur(iymenu(29)+1)) then
        if(keyval.eq.1.or.keyval.eq.3) go to 1111
      end if
c
      go to 119
c
112   continue
      tminc=min((tc(1)-orig)*tscale+tadj,(tc(2)-orig)*tscale+tadj)
      tmaxc=max((tc(1)-orig)*tscale+tadj,(tc(2)-orig)*tscale+tadj)
      npltc=nint((tmaxc-tminc)/sints)+1
      if(npltc.lt.2) then
        write(*,*, fmt="
     +       (/'***  must plot at least 2 points per trace  **')")
        write(*,*) char(7)
        go to 1199
      end if
      tmin=tminc
      tmax=tmaxc
      xmin=min((xc(1)-orig)*xscale+xminm,(xc(2)-orig)*xscale+xminm)
      xmax=max((xc(1)-orig)*xscale+xminm,(xc(2)-orig)*xscale+xminm)
c
113   continue
      ialign=0
1113  continue
      xmint=-999999.
      xmaxt=-999999.
      tmaxt=-999999.
      tmint=-999999.
      ndecix=-2
      ndecit=-2
      ntickx=-1
      ntickt=-1
c
114   continue
      if(iscreen.eq.1) write(*,*, fmt="(' ')")
c
      if(isegm.eq.1) then
        if(nseg.eq.100) go to 1111
ccc        call gsegcl(nseg)
        call segmnt
      end if
      if(iseg.eq.1) then
        nseg=nseg+1
        ibw=0
        ibcol=0
        ifcol=1
        if(icolour.eq.0) then
          do 573 i=1,5
573          colour(i)=ifcol
          do 577 i=1,npick
577          pickc(i)=ifcol
        end if
      end if
ccc      call rrect(0.,0.,xwin,ywin,ibcol,0.)
      call erase
c
      iprev=0
      if(iflags.eq.1.or.irec.eq.ishoth) go to 1001       
      go to 1002
c
ccc1111  if(iseg.eq.1) call gsegcl(nseg)
1111  if(iseg.eq.1) call segmnt
      call plotnd(0)
c
      close(10)
      close(11)
      close(13)
      close(14)
      close(16)
      close(17)
c
      if(iroute.eq.1) write(*,*, fmt="(/
     +  '--------------------------------------------'/
     +  '>>>  Run HEADUP if picks are to be kept  <<<'/
     +  '--------------------------------------------'/)")
c
      stop
      end
